import javax.microedition.lcdui.*;

public class SearchBox extends TextBox implements CommandListener
{ 
    List list;

    SearchBox(List list) { 
        super(Locale.ENTER_PREFIX, "", 8, TextField.ANY);       
        this.list = list;
        setCommandListener(this);
        addCommand(MetroNavigator.SEARCH_CMD);
        addCommand(MetroNavigator.BACK_CMD);
        Display.getDisplay(MetroNavigator.getInstance()).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {    
        MetroNavigator navigator = MetroNavigator.getInstance();
        if (c == MetroNavigator.SEARCH_CMD) {
            String prefix = getString().toUpperCase();
            for (int i = 0, n = list.size(); i < n; i++) {
                if (list.getString(i).toUpperCase().startsWith(prefix)) { 
                    list.setSelectedIndex(i, true);
                    Display.getDisplay(navigator).setCurrent(list);
                    return;
                }
            }
            navigator.showError("  ");
        } else { 
            Display.getDisplay(navigator).setCurrent(list);
        }
    }
}
    
