import java.util.*;

public class Scheme 
{ 
    public static Scheme instance;

    Line[] metroLines; 
    Cross[] metroCrosses;


    public Scheme(String schemeDefinition) { 
        metroLines = new Line[]{
            new Line("-", 0xFF3300, new Station[]{
                         new Station("", 2, 7, 177),
                         new Station("", 3, 54, 232),
                         new Station("", 2, 103, 231),
                         new Station("", 2, 151, 230),
                         new Station("", 3, 209, 234),
                         new Station("", 2, 256, 256),
                         new Station(" ", 3, 285, 276),
                         new Station("", 2, 314, 288),
                         new Station("", 2, 352, 290),
                         new Station("", 2, 390, 286),
                         new Station("", 3, 451, 311),
                         new Station("", 2, 486, 318),
                         new Station("", 2, 514, 312),
                         new Station("", 2, 557, 303),
                         new Station("", 2, 598, 284),
                         new Station("", 2, 638, 263),
                         new Station("", 2, 667, 248),
                         new Station("", 0, 729, 213)}), 
            new Line("-", 0x0020DA, new Station[]{
                         new Station(" ", 2, 395, 12),
                         new Station("", 2, 394, 62),
                         new Station("", 3, 391, 100),
                         new Station("", 2, 393, 160),
                         new Station(" ", 2, 415, 207),
                         new Station(" .", 2, 429, 233),
                         new Station(" .", 2, 440, 259),
                         new Station(".", 2, 442, 308),
                         new Station(". ", 2, 425, 362),
                         new Station(" ", 2, 413, 391),
                         new Station(" ", 2, 418, 441),
                         new Station("", 0, 430, 487)}), 
            new Line("-", 0x009737, new Station[]{
                         new Station("", 4, 222, 172),
                         new Station("", 5, 291, 206),
                         new Station(" ", 2, 380, 283),
                         new Station(" ", 2, 433, 364),
                         new Station("", 1, 449, 376),
                         new Station("", 1, 461, 394),
                         new Station(" ", 3, 478, 429),
                         new Station("", 5, 495, 454),
                         new Station("", 2, 601, 480),
                         new Station("", 2, 660, 465),
                         new Station("", 2, 690, 458),
                         new Station("", 0, 726, 451)})
        };


        metroCrosses = new Cross[] {
            new Cross(" ", "", 4),
            new Cross(". ", " ", 4),
            new Cross(".", "", 4)
        };
        instance = this;
    }
}
